// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus, Florian Fischer
#pragma once

#include <iostream>

/*! Enum representing the different environments where code can be executed */
enum CallerEnvironment {
	OWNER,		/*!< indicate code executed by the worker owning the object */
	EMPER,		/*!< indicate code executed by any worker */
	ANYWHERE, /*!< indicate code executed outside of any worker */
};

auto operator<<(std::ostream& os, const CallerEnvironment& callerEnvironment) -> std::ostream&;
