/// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2022 Florian Schmaus
#include "StealingMode.hpp"

#include <string>

namespace emper {

auto operator<<(std::ostream& out, const StealingMode& stealingMode) -> std::ostream& {
	switch (stealingMode) {
		case StealingMode::child:
			out << "child";
			break;
		case StealingMode::continuation:
			out << "continuation";
			break;
	}
	return out;
}

auto operator>>(std::istream& in, StealingMode& stealingMode) -> std::istream& {
	std::string token;

	in >> token;
	if (token == "child") {
		stealingMode = StealingMode::child;
	} else if (token == "continuation") {
		stealingMode = StealingMode::continuation;
	} else {
		in.setstate(std::ios_base::failbit);
	}

	return in;
}

}	 // namespace emper
