// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2022 Florian Schmaus
#include "lib/util.hpp"

#include <utility>
#include <vector>

#include "lib/template_util.hpp"

namespace tu = emper::lib::template_util;

namespace emper::lib::util {

auto bytesToHumanReadableString(uintptr_t bytes) -> std::string {
	auto res = tu::toHumanReadableBytes(bytes);

	std::stringstream sstrm;
	sstrm << res.first << " " << res.second << " (" << bytes << " B)";
	return sstrm.str();
}

void writeByteStats(uintptr_t bytes, std::ostream& out) {
	auto res = tu::toHumanReadableBytes(bytes);
	out << bytes << " (" << res.first << " " << res.second << ")";
}

void writeByteStats(const std::string&& name, uintptr_t bytes, std::ostream& out) {
	out << name << ": ";
	writeByteStats(bytes, out);
	out << std::endl;
}

}	 // namespace emper::lib::util
