// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021-2022 Florian Schmaus
#include <atomic>
#include <cstdlib>

#include "Fibril.hpp"

static const unsigned int COUNT = 3;
static std::atomic_uint counter;

static void increaseCounterByOne() { counter++; }

// NOLINTNEXTLINE(clang-diagnostic-unknown-attributes)
emper_fibril void emperTest() {
	Fibril fibril;

	for (unsigned int i = 0; i < COUNT; ++i) {
		fibril.fork(increaseCounterByOne);
	}

	fibril.join();

	if (counter != COUNT) {
		exit(EXIT_FAILURE);
	}
}
